diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
index d41a4f95f..d5382c169 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
@@ -48,20 +48,20 @@ public class TileEntityMobSpawner extends TileEntity {
     }
 
     public boolean anyPlayerInRange() {
-        return this.worldObj != null && this.worldObj.getClosestPlayer((double) this.x + 0.5D, (double) this.y + 0.5D, (double) this.z + 0.5D, 16D) != null;
+        return this.worldObj != null && this.worldObj.getClosestPlayer((double) this.tilePos.x + 0.5D, (double) this.tilePos.y + 0.5D, (double) this.tilePos.z + 0.5D, 16D) != null;
     }
 
     @Override
     public void tick() {
-        if (this.worldObj.getBlockId(this.x, this.y, this.z) != Blocks.MOBSPAWNER.id())
+        if (this.worldObj.getBlockId(this.tilePos.x, this.tilePos.y, this.tilePos.z) != Blocks.MOBSPAWNER.id())
             return; // dumb fix for mp particle bug, need proper way to inform client to remove tileEntity
         this.yaw2 = this.yaw;
         if (!anyPlayerInRange()) {
             return;
         }
-        double xPos = (double) this.x + this.worldObj.rand.nextFloat();
-        double yPos = (double) this.y + this.worldObj.rand.nextFloat();
-        double zPos = (double) this.z + this.worldObj.rand.nextFloat();
+        double xPos = (double) this.tilePos.x + this.worldObj.rand.nextFloat();
+        double yPos = (double) this.tilePos.y + this.worldObj.rand.nextFloat();
+        double zPos = (double) this.tilePos.z + this.worldObj.rand.nextFloat();
         this.worldObj.spawnParticle("smoke", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
         this.worldObj.spawnParticle("flame", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
         for (this.yaw += 1000F / ((float) this.delay + 200F); this.yaw > 360D; ) {
@@ -93,16 +93,16 @@ public class TileEntityMobSpawner extends TileEntity {
                 if (mob == null) {
                     return;
                 }
-                AABBd checkBB = new AABBd(this.x, this.y, this.z, this.x + 1, this.y + 1, this.z + 1);
+                AABBd checkBB = new AABBd(this.tilePos.x, this.tilePos.y, this.tilePos.z, this.tilePos.x + 1, this.tilePos.y + 1, this.tilePos.z + 1);
                 MathHelper.aabbGrow(checkBB, 8, 4, 8, checkBB);
                 int nearbySpawnCount = this.worldObj.getEntitiesWithinAABB(mob.getClass(), checkBB).size();
                 if (nearbySpawnCount >= 6) {
                     updateDelay();
                     return;
                 }
-                double d6 = (double) this.x + (this.worldObj.rand.nextDouble() - this.worldObj.rand.nextDouble()) * 4D;
-                double d7 = (this.y + this.worldObj.rand.nextInt(3)) - 1;
-                double d8 = (double) this.z + (this.worldObj.rand.nextDouble() - this.worldObj.rand.nextDouble()) * 4D;
+                double d6 = (double) this.tilePos.x + (this.worldObj.rand.nextDouble() - this.worldObj.rand.nextDouble()) * 4D;
+                double d7 = (this.tilePos.y + this.worldObj.rand.nextInt(3)) - 1;
+                double d8 = (double) this.tilePos.z + (this.worldObj.rand.nextDouble() - this.worldObj.rand.nextDouble()) * 4D;
                 mob.moveTo(d6, d7, d8, this.worldObj.rand.nextFloat() * 360F, 0.0F);
                 if (!mob.canSpawnHere()) {
                     updateDelay();
@@ -111,9 +111,9 @@ public class TileEntityMobSpawner extends TileEntity {
                 mob.spawnInit();
                 this.worldObj.entityJoinedWorld(mob);
                 for (int k = 0; k < 20; k++) {
-                    double d1 = (double) this.x + 0.5D + ((double) this.worldObj.rand.nextFloat() - 0.5D) * 2D;
-                    double d3 = (double) this.y + 0.5D + ((double) this.worldObj.rand.nextFloat() - 0.5D) * 2D;
-                    double d5 = (double) this.z + 0.5D + ((double) this.worldObj.rand.nextFloat() - 0.5D) * 2D;
+                    double d1 = (double) this.tilePos.x + 0.5D + ((double) this.worldObj.rand.nextFloat() - 0.5D) * 2D;
+                    double d3 = (double) this.tilePos.y + 0.5D + ((double) this.worldObj.rand.nextFloat() - 0.5D) * 2D;
+                    double d5 = (double) this.tilePos.z + 0.5D + ((double) this.worldObj.rand.nextFloat() - 0.5D) * 2D;
                     this.worldObj.spawnParticle("smoke", d1, d3, d5, 0.0D, 0.0D, 0.0D, 0);
                     this.worldObj.spawnParticle("flame", d1, d3, d5, 0.0D, 0.0D, 0.0D, 0);
                     this.worldObj.playSoundAtEntity(null, mob, "tile.mobspawner.spawn", 0.025F, 0.75F);
@@ -129,16 +129,16 @@ public class TileEntityMobSpawner extends TileEntity {
 
     @Override
     public Packet getDescriptionPacket() {
-        return new PacketSetMobSpawner(new TilePos(this.x, this.y, this.z), EntityDispatcher.getInstance().entryForId(this.mobId));
+        return new PacketSetMobSpawner(new TilePos(this.tilePos.x, this.tilePos.y, this.tilePos.z), EntityDispatcher.getInstance().entryForId(this.mobId));
     }
 
     public int countNearbySpawners() {
         int r = 4;
         int count = 0;
         TilePos tilePos = new TilePos(0, 0, 0);
-        for (tilePos.x = this.x -r; tilePos.x <= this.x + r; tilePos.x++) {
-            for (tilePos.y = this.y -r; tilePos.y <= this.y + r; tilePos.y++) {
-                for (tilePos.z = this.z -r; tilePos.z <= this.z + r; tilePos.z++) {
+        for (tilePos.x = this.tilePos.x -r; tilePos.x <= this.tilePos.x + r; tilePos.x++) {
+            for (tilePos.y = this.tilePos.y -r; tilePos.y <= this.tilePos.y + r; tilePos.y++) {
+                for (tilePos.z = this.tilePos.z -r; tilePos.z <= this.tilePos.z + r; tilePos.z++) {
                     if (this.worldObj.getBlockType(tilePos) == Blocks.MOBSPAWNER) {
                         count++;
                     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java
index 29dfd3d60..34aa63190 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java
@@ -19,8 +19,8 @@ public class TileEntityNoteblock extends TileEntity
 
     @Override
     public void tick() {
-        if (worldObj.getBlock(x, y, z) == Blocks.NOTEBLOCK) { // Set note block pitch
-            worldObj.setBlockMetadata(x, y, z, BlockLogicNote.setNote(0, note));
+        if (worldObj.getBlock(tilePos.x, tilePos.y, tilePos.z) == Blocks.NOTEBLOCK) { // Set note block pitch
+            worldObj.setBlockMetadata(tilePos.x, tilePos.y, tilePos.z, BlockLogicNote.setNote(0, note));
         }
         invalidate(); // Delete self
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
index 96c2e51bc..865105139 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
@@ -35,7 +35,7 @@ public class TileEntitySeat
         }
 
         // TODO the server really needs a better way of telling the client that a tile entity no longer exists, but this works to fix the client thinking that the seat remains if its broken in multiplayer
-        if (worldObj != null && worldObj.getBlock(x, y, z) != seat) {
+        if (worldObj != null && worldObj.getBlock(tilePos.x, tilePos.y, tilePos.z) != seat) {
             ejectRider();
         }
     }
@@ -59,9 +59,9 @@ public class TileEntitySeat
             y = carriedBlock.holder.y;
             z = carriedBlock.holder.z;
         } else {
-            x = this.x;
-            y = this.y;
-            z = this.z;
+            x = this.tilePos.x;
+            y = this.tilePos.y;
+            z = this.tilePos.z;
         }
 
         if (isSafe(x, y + 1, z)) {
@@ -96,7 +96,7 @@ public class TileEntitySeat
         if (carriedBlock != null) {
             passenger.setPos(carriedBlock.holder.x, carriedBlock.holder.y + passenger.getRidingHeight(), carriedBlock.holder.z);
         } else {
-            passenger.setPos(this.x + 0.5, this.y + 0.5 + passenger.getRidingHeight(), z + 0.5);
+            passenger.setPos(this.tilePos.x + 0.5, this.tilePos.y + 0.5 + passenger.getRidingHeight(), tilePos.z + 0.5);
         }
     }
 
@@ -120,7 +120,7 @@ public class TileEntitySeat
         if (carriedBlock != null) {
             entity.moveTo(carriedBlock.holder.x, carriedBlock.holder.y + 2, carriedBlock.holder.z, entity.yRot, entity.xRot);
         } else {
-            entity.moveTo(this.x, this.y + 2, this.z, entity.yRot, entity.xRot);
+            entity.moveTo(this.tilePos.x, this.tilePos.y + 2, this.tilePos.z, entity.yRot, entity.xRot);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
index 53f8f7553..c9fa51b5b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
@@ -69,17 +69,16 @@ public class TileEntitySensor extends TileEntity {
             return;
         }
 
-        int id = this.worldObj.getBlockId(this.x, this.y, this.z);
-        int meta = this.worldObj.getBlockMetadata(this.x, this.y, this.z);
+        int id = this.worldObj.getBlockId(this.tilePos.x, this.tilePos.y, this.tilePos.z);
+        int meta = this.worldObj.getBlockMetadata(this.tilePos.x, this.tilePos.y, this.tilePos.z);
 
         boolean shouldBeActive = false;
         Direction facing = BlockLogicVeryRotatable.metaToDirection(meta);
-        int effectiveRange = getSightRange(this.worldObj, this.x, this.y, this.z, facing);
+        int effectiveRange = getSightRange(this.worldObj, this.tilePos.x, this.tilePos.y, this.tilePos.z, facing);
         if (effectiveRange > 0) {
-            AABBdc detectionBox = getDetectionBox(this.x, this.y, this.z, facing, effectiveRange);
+            AABBdc detectionBox = getDetectionBox(this.tilePos.x, this.tilePos.y, this.tilePos.z, facing, effectiveRange);
             List<Entity> list = this.worldObj.getEntitiesWithinAABBExcludingEntity(null, detectionBox);
-            for (int i = 0; i < list.size(); i++) {
-                Entity entity = list.get(i);
+            for (Entity entity : list) {
                 if (entity.canInteract()) {
                     if (entity instanceof Player player) {
                         player.triggerAchievement(Achievements.GET_SENSED);
@@ -90,7 +89,7 @@ public class TileEntitySensor extends TileEntity {
         }
 
         if (shouldBeActive && id == Blocks.MOTION_SENSOR_IDLE.id()) {
-            this.worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, this.x + 0.5, this.y + 0.5, this.z + 0.5, "tile.sensor_block.sense", 1f, this.worldObj.rand.nextFloat());
+            this.worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, this.tilePos.x + 0.5, this.tilePos.y + 0.5, this.tilePos.z + 0.5, "tile.sensor_block.sense", 1f, this.worldObj.rand.nextFloat());
             updateSensorBlockState(true, this.worldObj);
         }
         if (!shouldBeActive && id == Blocks.MOTION_SENSOR_ACTIVE.id()) {
@@ -135,7 +134,7 @@ public class TileEntitySensor extends TileEntity {
         }
 
         if (shouldBeActive && id == Blocks.MOTION_SENSOR_IDLE.id()) {
-            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, this.x + 0.5, this.y + 0.5, this.z + 0.5, "tile.sensor_block.sense", 1f, world.rand.nextFloat());
+            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, this.tilePos.x + 0.5, this.tilePos.y + 0.5, this.tilePos.z + 0.5, "tile.sensor_block.sense", 1f, world.rand.nextFloat());
             updateSensorBlockState(true, world);
         }
         if (!shouldBeActive && id == Blocks.MOTION_SENSOR_ACTIVE.id()) {
@@ -151,16 +150,16 @@ public class TileEntitySensor extends TileEntity {
                 this.carriedBlock.blockId = Blocks.MOTION_SENSOR_IDLE.id();
             }
         } else {
-            int meta = world.getBlockMetadata(this.x, this.y, this.z);
+            int meta = world.getBlockMetadata(this.tilePos.x, this.tilePos.y, this.tilePos.z);
             int blockId;
             if (active) {
                 blockId = Blocks.MOTION_SENSOR_ACTIVE.id();
             } else {
                 blockId = Blocks.MOTION_SENSOR_IDLE.id();
             }
-            world.setBlock(this.x, this.y, this.z, blockId);
-            world.setBlockMetadata(this.x, this.y, this.z, meta);
-            world.notifyBlockChange(this.x, this.y, this.z, blockId);
+            world.setBlock(this.tilePos.x, this.tilePos.y, this.tilePos.z, blockId);
+            world.setBlockMetadata(this.tilePos.x, this.tilePos.y, this.tilePos.z, meta);
+            world.notifyBlockChange(this.tilePos.x, this.tilePos.y, this.tilePos.z, blockId);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
index 6901bc2bf..cf28b7b55 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
@@ -195,7 +195,7 @@ public class TileEntityTrommel extends TileEntity
         }
         if(!isClient)
         {
-        	if(this.worldObj == null || this.worldObj.getBlockId(this.x, this.y, this.z) == Blocks.TROMMEL_IDLE.id()) {
+        	if(this.worldObj == null || this.worldObj.getBlockId(this.tilePos.x, this.tilePos.y, this.tilePos.z) == Blocks.TROMMEL_IDLE.id()) {
             	if(this.currentItemBurnTime == 0 && this.itemStacks[SLOTS_INGREDIENT[0]] == null && this.itemStacks[SLOTS_INGREDIENT[1]] == null && this.itemStacks[SLOTS_INGREDIENT[2]] == null && this.itemStacks[SLOTS_INGREDIENT[3]] == null) {
             		if(this.itemStacks[SLOT_FUEL] != null && this.itemStacks[SLOT_FUEL].itemID == Blocks.COBBLE_NETHERRACK.id()) {
                         this.itemStacks[SLOT_FUEL].stackSize--;
@@ -203,7 +203,7 @@ public class TileEntityTrommel extends TileEntity
                             this.itemStacks[SLOT_FUEL] = null;
                         }
             			if (this.worldObj != null) {
-                            BlockLogicTrommel.updateTrommelBlockState(this.worldObj, new TilePos(this.x, this.y, this.z), true);
+                            BlockLogicTrommel.updateTrommelBlockState(this.worldObj, new TilePos(this.tilePos.x, this.tilePos.y, this.tilePos.z), true);
                         } else if (this.carriedBlock != null) {
                             this.carriedBlock.blockId = Blocks.TROMMEL_ACTIVE.id();
                         }
@@ -252,7 +252,7 @@ public class TileEntityTrommel extends TileEntity
             {
                 flag1 = true;
                 if (this.worldObj != null) {
-                    BlockLogicTrommel.updateTrommelBlockState(this.worldObj, new TilePos(this.x, this.y, this.z), this.burnTime > 0);
+                    BlockLogicTrommel.updateTrommelBlockState(this.worldObj, new TilePos(this.tilePos.x, this.tilePos.y, this.tilePos.z), this.burnTime > 0);
                 } else if (this.carriedBlock != null) {
                     this.carriedBlock.blockId = this.burnTime > 0 ? Blocks.TROMMEL_ACTIVE.id() : Blocks.TROMMEL_IDLE.id();
                 }
@@ -285,7 +285,7 @@ public class TileEntityTrommel extends TileEntity
         Direction direction = Direction.NONE;
         if (this.worldObj != null) {
             // 90-degree rotation CCW around the y-axis to get the direction of the output slot
-            switch (BlockLogicRotatable.getDirectionFromMeta(this.worldObj.getBlockMetadata(this.x, this.y, this.z))) {
+            switch (BlockLogicRotatable.getDirectionFromMeta(this.worldObj.getBlockMetadata(this.tilePos.x, this.tilePos.y, this.tilePos.z))) {
                 case NORTH: {
                     direction = Direction.WEST;
                     break;
@@ -309,9 +309,9 @@ public class TileEntityTrommel extends TileEntity
         {
         	// Check if chest is adjacent
 
-        	int adjacentId = this.worldObj != null ? this.worldObj.getBlockId(this.x + direction.getOffsetX(), this.y + direction.getOffsetY(), this.z + direction.getOffsetZ()) : 0;
+        	int adjacentId = this.worldObj != null ? this.worldObj.getBlockId(this.tilePos.x + direction.getOffsetX(), this.tilePos.y + direction.getOffsetY(), this.tilePos.z + direction.getOffsetZ()) : 0;
         	if (this.worldObj != null && Block.hasLogicClass(Blocks.blocksList[adjacentId], BlockLogicChest.class)) {
-                Container chest = BlockLogicChest.getInventory(this.worldObj, new TilePos(this.x + direction.getOffsetX(), this.y + direction.getOffsetY(), this.z + direction.getOffsetZ()));
+                Container chest = BlockLogicChest.getInventory(this.worldObj, new TilePos(this.tilePos.x + direction.getOffsetX(), this.tilePos.y + direction.getOffsetY(), this.tilePos.z + direction.getOffsetZ()));
 
                 for (int i = 0; i < chest.getContainerSize(); i++)
                 {
@@ -341,13 +341,13 @@ public class TileEntityTrommel extends TileEntity
 
             if(itemResult.stackSize > 0) {
                 if (this.worldObj != null) {
-                    if (this.worldObj.isAirBlock(new TilePos(this.x, this.y, this.z).add(direction))) {
-                        EntityItem droppedItem = new EntityItem(this.worldObj, this.x + 0.5 + direction.getOffsetX() * 0.5, this.y + 0.5 + direction.getOffsetY() * 0.5, this.z + 0.5 + direction.getOffsetZ() * 0.5, itemResult);
+                    if (this.worldObj.isAirBlock(new TilePos(this.tilePos.x, this.tilePos.y, this.tilePos.z).add(direction))) {
+                        EntityItem droppedItem = new EntityItem(this.worldObj, this.tilePos.x + 0.5 + direction.getOffsetX() * 0.5, this.tilePos.y + 0.5 + direction.getOffsetY() * 0.5, this.tilePos.z + 0.5 + direction.getOffsetZ() * 0.5, itemResult);
                         droppedItem.pickupDelay = 10;
                         droppedItem.fling(direction.getOffsetX() * 0.3125, direction.getOffsetY() * 0.3125, direction.getOffsetZ() * 0.3125, 1);
                         this.worldObj.entityJoinedWorld(droppedItem);
                     } else {
-                        this.worldObj.dropItem(this.x, this.y, this.z, itemResult);
+                        this.worldObj.dropItem(this.tilePos.x, this.tilePos.y, this.tilePos.z, itemResult);
                     }
                 } else if (this.carriedBlock != null) {
                     this.carriedBlock.world.dropItem(MathHelper.floor(this.carriedBlock.holder.x), MathHelper.floor(this.carriedBlock.holder.y), MathHelper.floor(this.carriedBlock.holder.z), itemResult);
@@ -366,11 +366,11 @@ public class TileEntityTrommel extends TileEntity
             mobSlime.yd = (float) this.random.nextGaussian() * f3 + 0.2F;
             mobSlime.zd = (float) this.random.nextGaussian() * f3;
             if (this.worldObj != null) {
-                if (this.worldObj.isAirBlock(new TilePos(this.x, this.y, this.z).add(direction))) {
-                    mobSlime.moveTo(this.x + 0.5 + direction.getOffsetX(), this.y + 0.5 + direction.getOffsetY(), this.z + 0.5 + direction.getOffsetZ(), this.random.nextFloat() * 360F, 0.0F);
+                if (this.worldObj.isAirBlock(new TilePos(this.tilePos.x, this.tilePos.y, this.tilePos.z).add(direction))) {
+                    mobSlime.moveTo(this.tilePos.x + 0.5 + direction.getOffsetX(), this.tilePos.y + 0.5 + direction.getOffsetY(), this.tilePos.z + 0.5 + direction.getOffsetZ(), this.random.nextFloat() * 360F, 0.0F);
                     mobSlime.fling(direction.getOffsetX() * 0.75, direction.getOffsetY() * 0.75, direction.getOffsetZ() * 0.75, 1);
                 } else {
-                    mobSlime.moveTo(this.x + (double)f, this.y + 1D, this.z + (double)f1, this.random.nextFloat() * 360F, 0.0F);
+                    mobSlime.moveTo(this.tilePos.x + (double)f, this.tilePos.y + 1D, this.tilePos.z + (double)f1, this.random.nextFloat() * 360F, 0.0F);
                 }
                 this.worldObj.entityJoinedWorld(mobSlime);
             } else if (this.carriedBlock != null) {
@@ -416,11 +416,11 @@ public class TileEntityTrommel extends TileEntity
     @Override
 	public boolean stillValid(@NotNull Player player)
     {
-        if(this.worldObj == null || this.worldObj.getTileEntity(this.x, this.y, this.z) != this)
+        if(this.worldObj == null || this.worldObj.getTileEntity(this.tilePos.x, this.tilePos.y, this.tilePos.z) != this)
         {
             return false;
         }
-        return player.distanceToSqr((double) this.x + 0.5D, (double) this.y + 0.5D, (double) this.z + 0.5D) <= 64D;
+        return player.distanceToSqr((double) this.tilePos.x + 0.5D, (double) this.tilePos.y + 0.5D, (double) this.tilePos.z + 0.5D) <= 64D;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
index e1c81ee17..c4dfde503 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
@@ -123,7 +123,7 @@ public class TileEntityMovingPistonBlock extends TileEntity
         } else {
             stretch = 1.0F - stretch;
         }
-        AABBdc aabb = Blocks.PISTON_MOVING.getLogic().getCollisionShapeFromTileEntity(this.worldObj, new TilePos(this.x, this.y, this.z), this.movedBlock, stretch, this.direction);
+        AABBdc aabb = Blocks.PISTON_MOVING.getLogic().getCollisionShapeFromTileEntity(this.worldObj, new TilePos(this.tilePos.x, this.tilePos.y, this.tilePos.z), this.movedBlock, stretch, this.direction);
         if (aabb == null) return;
 
         List<Entity> list = this.worldObj.getEntitiesWithinAABBExcludingEntity(null, aabb);
@@ -139,7 +139,7 @@ public class TileEntityMovingPistonBlock extends TileEntity
     }
 
     public void finalTick() {
-        TilePos selfPos = new TilePos(this.x, this.y, this.z);
+        TilePos selfPos = new TilePos(this.tilePos.x, this.tilePos.y, this.tilePos.z);
         assert this.worldObj != null;
 
         this.progressO = this.progress = 1.0F;
@@ -153,9 +153,9 @@ public class TileEntityMovingPistonBlock extends TileEntity
                     oldEnt.invalidate();
                 }
                 this.movedEntity.validate();
-                this.movedEntity.x = this.x;
-                this.movedEntity.y = this.y;
-                this.movedEntity.z = this.z;
+                this.movedEntity.tilePos.x = this.tilePos.x;
+                this.movedEntity.tilePos.y = this.tilePos.y;
+                this.movedEntity.tilePos.z = this.tilePos.z;
                 this.worldObj.replaceTileEntity(selfPos, this.movedEntity);
             }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index b2ad0861b..0565659ba 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -19,11 +19,7 @@ import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.collection.NamespaceID;
-import net.minecraft.core.util.helper.DamageType;
-import net.minecraft.core.util.helper.Direction;
-import net.minecraft.core.util.helper.DyeColor;
-import net.minecraft.core.util.helper.LightIndexHelper;
-import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.*;
 import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.World;
@@ -240,26 +236,28 @@ public abstract class Entity
         this.zo = this.z;
         this.xRotO = this.xRot;
         this.yRotO = this.yRot;
+
         // Removed at jonks request, should work though if it ever wants to be uncommented
-//        if (isSprinting())
-//        {
-//            int x = MathHelper.floor_double(this.x);
-//            int y = MathHelper.floor_double(this.y - 0.2 - (double)heightOffset);
-//            int z = MathHelper.floor_double(this.z);
-//            int floorBlock = world.getBlockId(x, y, z);
-//            int meta = world.getBlockMetadata(x, y, z);
-//            if (floorBlock > 0)
-//            {
-//                world.spawnParticle("block",
-//                    this.x + ((double)random.nextFloat() - 0.5D) * (double)bbWidth,
-//                    bb.minY + 0.1,
-//                    this.z + ((double)random.nextFloat() - 0.5D) * (double)bbWidth,
-//                    -xd * 4D,
-//                    1.5D,
-//                    -zd * 4D,
-//                        BlockParticleHelper.encodeBlockData(floorBlock, meta, Side.TOP));
-//            }
-//        }
+        // ^ IDK bro just crashes the game now
+/*        if (isSprinting())
+        {
+            int x = MathHelper.floor(this.x);
+            int y = MathHelper.floor(this.y - 0.2 - (double)heightOffset);
+            int z = MathHelper.floor(this.z);
+            int floorBlock = world.getBlockId(x, y, z);
+            int meta = world.getBlockMetadata(x, y, z);
+            if (floorBlock > 0)
+            {
+                world.spawnParticle("block",
+                    this.x + ((double)random.nextFloat() - 0.5D) * (double)bbWidth,
+                    bb.minY + 0.1,
+                    this.z + ((double)random.nextFloat() - 0.5D) * (double)bbWidth,
+                    -xd * 4D,
+                    1.5D,
+                    -zd * 4D,
+                        BlockParticleHelper.encodeBlockData(floorBlock, meta, Side.TOP));
+            }
+        }*/
 
         checkOnWater(true);
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java b/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
index d16e36dfc..4b483ea9f 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
@@ -164,9 +164,9 @@ public class EntityFallingBlock extends Entity
                             oldEnt.invalidate();
                         }
                         this.carriedBlock.entity.validate();
-                        this.carriedBlock.entity.x = blockPos.x();
-                        this.carriedBlock.entity.y = blockPos.y();
-                        this.carriedBlock.entity.z = blockPos.z();
+                        this.carriedBlock.entity.tilePos.x = blockPos.x();
+                        this.carriedBlock.entity.tilePos.y = blockPos.y();
+                        this.carriedBlock.entity.tilePos.z = blockPos.z();
                         this.carriedBlock.entity.worldObj = this.world;
                         this.carriedBlock.entity.carriedBlock = null;
                         this.world.replaceTileEntity(blockPos, this.carriedBlock.entity);
